%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%define testdir %{_datadir}/autotest/client/site_tests
%define eventdir %{_datadir}/autoqa/events
%define watcherdir %{_datadir}/autoqa/watchers
# TODO split python library into subpackage?

Name: autoqa
Summary: Automated quality assurance framework
Version: 0.5.1
Release: 1%{?dist}
Source: https://fedorahosted.org/released/%{name}/%{name}-%{version}.tar.gz
License: GPLv2+
Group: Applications/Internet
URL: https://fedorahosted.org/autoqa
Requires: autotest
Requires: koji
Requires: mod_wsgi
Requires: python-fedora
Requires: python-peak-util-symbols
# hashlib is packaged seperately in EPEL-5
%if 0%{?el5}
Requires: python-hashlib
Requires: python-wsgiref
%endif
BuildRequires: python2-devel
%if 0%{?fedora}
# Packages needed by 'make test' (not present in RHEL)
BuildRequires: python-virtualenv
BuildRequires: python-pip
BuildRequires: python-peak-util-symbols
BuildRequires: python-bunch
BuildRequires: python-urlgrabber
BuildRequires: python-fedora
BuildRequires: yum
BuildRequires: koji
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch: noarch


%description
The autoqa project to provides a basic framework for executing a series of
tests, the tests, and a series of watcher scripts designed to execute tests
under certain conditions.


%prep
%setup -q


%if 0%{?fedora}
%check
make test
%else
echo "Not running tests on non-fedora"
%endif


%build
make build PYTHON=%{__python}


%install
rm -rf $RPM_BUILD_ROOT
make install PREFIX=$RPM_BUILD_ROOT TEST_DIR=%{testdir} EVENT_DIR=%{eventdir} WATCHER_DIR=%{watcherdir} PYTHON=%{__python}


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc README LICENSE TODO conf/autoqa.cron
%dir %{_sysconfdir}/autoqa
%config(noreplace) %{_sysconfdir}/autoqa/autoqa.conf
%config(noreplace) %attr(0640,autoqa,autotest) %{_sysconfdir}/autoqa/fas.conf
%config %{_sysconfdir}/autoqa/repoinfo.conf
%config %{_sysconfdir}/autoqa/log_template.html
%config(noreplace) %{testdir}/rats_sanity/irb.cfg
%config(noreplace) %{_sysconfdir}/httpd/conf.d/autoqa-git-hook.conf
%dir %attr(0775,root,autotest) %{_localstatedir}/cache/autoqa
%{_bindir}/autoqa
%{_sbindir}/autoqa-git-hook.wsgi
%{testdir}
%{eventdir}
%{watcherdir}
%{_datadir}/autotest/client/bin/site_utils.py*
%{_datadir}/autotest/server/site_autotest.py*
%{python_sitelib}/autoqa*


%changelog
* Fri Jul 15 2011 James Laska <jlaska@redhat.com> - 0.5.1-1
 - Release of autoqa-0.5.1
 - Updated Makefile targets for improved package builds/updates (jlaska)
 - compose_tree - Support for multiple packages using either -p or -x.  Improve
   handling of result files. (jlaska)
 - koji-bodhi - Fix failure to acquire lock when cachedir is missing (jlaska)
 - git-post-receive - Update wsgi configuration (jlaska)
 - Fix for #346 - keep comments from being mangled before posting to bodhi
   (tflink)

* Thu Jun 27 2011 James Laska <jlaska@redhat.com> - 0.5.0-1
 - Release of autoqa-0.5.0
 - Ticket#344 - update repoinfo.conf for Fedora 13 EOL (jlaska)

* Thu Jun 23 2011 James Laska <jlaska@redhat.com> - 0.5.0-0.3.pre
 - Added links to the trac wiki page with more configuration details (tflink)
 - pretty_log: improve highlight keyword (kparal)
 - Ticket#342 - Prevent duplicate tests scheduling (jskladan)
 - Improving debug logging output for bodhi comment email logic (tflink)
 - Ticket#343 - problems with bodhi comment email logic (tflink)
 - autoqa.conf: make it more readable (kparal)
 - post-bodhi-update: require --title (kparal)
 - code formatting change (kparal)
 - depcheck: add kojitag to log overview (kparal)
 - test.py: limit the length of summary for crashed tests (kparal)

* Mon Jun 13 2011 James Laska <jlaska@redhat.com> - 0.5.0-0.2.pre
 - pretty_log: colorize result (kparal)
 - detect python version in runtests.sh instead of assuming 2.7 (tflink)

* Fri Jun 10 2011 James Laska <jlaska@redhat.com> - 0.5.0-0.1.pre
 - Pre-release of 0.5.0 (tflink)

* Thu Apr 28 2011 James Laska <jlaska@redhat.com> - 0.4.7-1
 - bodhi_utils: don't place dot after hyperlink (kparal)
 - Ticket#294 - Included link to help maintainers resolve upgradepath failures
   (vhumpa)
 - Ticket#308 - keeps depcheck from crashing or scheduling tests when there are
   no builds to test (tflink)
 - upgradepath: don't crash when Bodhi update is broken (kparal)
 - depcheck: detect broken Bodhi updates (kparal)
 - bodhi_utils: emphasize in comments that AutoQA is not enforcing anything
   (kparal)
 - Ticket#306 - bodhi_utils: don't report changed updates as tested (vhumpa)
 - upgradepath: fix the algorithm when pushing to older -updates repo (kparal)

* Mon Apr 11 2011 James Laska <jlaska@redhat.com> - 0.4.6-1
 - Ticket#293 - CmdError: No more mirrors to try (tflink)
 - autoqa-git-hook: Improved error detection and bad input handling (jlaska)

* Tue Apr 05 2011 James Laska <jlaska@redhat.com> - 0.4.5-1
 - Ticket#297 - depcheck reporting rejected builds as ignored (jskladan)
 - Ticket#292 - When publishing results to bodhi, link to output.log (tflink)
 - Ticket#286 - upgradepath reporting; minor depcheck changes (kparal)
 - initscripts: fix unassigned variable causing crash (kparal)

* Wed Mar 23 2011 James Laska <jlaska@redhat.com> - 0.4.4-3
- depcheck: improve highlights, assert for correct depcheck output (kparal)

* Wed Mar 16 2011 James Laska <jlaska@redhat.com> - 0.4.4-2
- Ticket#265 - Create function to download RPMs from koji for given NVR (tflink)
- compose_tree: several improvements for proper execution using mock, smaller
  ks package footprint and argument handling (jlaska)
- anaconda_checkbot, anaconda_storage: minor wrapper improvements (jlaska)
- Various fixes to support autoqa and watcher execution on RHEL-5 (jlaska)

* Tue Mar 15 2011 James Laska <jlaska@redhat.com> - 0.4.4-1
- depcheck: fix crash related to rejected packages (#279) (kparal)
- post-koji-build: Add --tag|-t option to watch-koji-builds.py (jlaska)

* Fri Mar 11 2011 James Laska <jlaska@redhat.com> - 0.4.4-0.3.pre
- Spec cleanup, remove BuildRequires:autotest and duplicate install code, add
  missing BuildRequires:python2-devel (jlaska)
- Updated to autoqa-0.4.4-0.3.pre (jlaska)
- depcheck: use koji tags to get pending builds, don't crash for invalid builds
 (kparal)
- depcheck: set ABORTED status when downloading a package fails (kparal)
- depcheck: add kojitag to summary (kparal)
- Fixed depcheck's not reporting failed results. (jskladan)
- watch-koji-builds: fix broken UTC time conversions (kparal)
- upgradepath: don't crash when nonexistent build approached (kparal)

* Tue Mar 08 2011 James Laska <jlaska@redhat.com> - 0.4.4-0.2.pre
- upgradepath: run on post-bodhi-update-batch, test all updates, send bodhi
  comments (kparal)
- depcheck: enable scheduling for -batch event (jskladan)
- Stop using epoch in NVR variables (kparal, jskladan)
- Replace old bodhi watcher with new koji watcher (jskladan)
- Ticket#269 - update repoinfo.conf for Fedora 15 branch (jlaska)
- Add a setup method to the no-swap-lvm test suite. (clumens)
- Update documentation in testclass template regarding email subject (kparal)
- bodhi_already_commented() does not require user arg anymore (kparal)
- New test - depcheck (wwoods)

* Tue Jan 25 2011 James Laska <jlaska@redhat.com> - 0.4.4-0.1.pre
- Add BuildRequire: autotest (jlaska)
- Copy config files to clients in a better way (jlaska)
- Add query_update() to autoqa.bodhi_utils (kparal)
- New hook - git-post-recieve jlaska)
- New test - anaconda_storage (clumens)
- New test - compose_tree pungi (jlaska)
- New test - anaconda_checkbot (clumens, jlaska)
- Use self.__class__ in super() calls (kparal)
- Repoinfo.conf: set 'composes = no' as default for correct retyping (kparal)
- Bugfix: getbool() crashes for empty string (kparal)
- Load config files from current directory by default (kparal)
- Add support for a staging server (mkrizek)
- Remove israwhidebroken sub-package. (jlaska)
- Provide support for sending comments to Bodhi (mkrizek)
- Rpmlint: install all required packages at once (kparal)
- Fedora 12 is EOL, remove it from repoinfo.conf (kparal)
- Removed anaconda test and move it to a separate branch (kparal)
- Return non-zero exit status when job scheduling fails (kparal)
- Updated the test template (jskladan)
- Replace repoinfo.conf on upgrade (kparal)
- Watch-koji-builds: improve verbose output (kparal)
- Ticket#207 - Use correct list of tags when looking for koji builds (jlaska)
- Ticket#210 - renamed url parameter to baseurl (jskladan)
- Fix broken arguments for many tests (kparal)
- Modified templates for all hooks for new autoqa script (vaschenb)
- New control files for new autoqa script with params in dict (vaschenb)
- Hello world test (vaschenb)
- Autoqa script passing arguments via dictionary (vaschenb)

* Mon Nov 15 2010 James Laska <jlaska@redhat.com> - 0.4.3-1
- Cleanup repoinfo.conf for new F-14 release and expired releases (jlaska)
- Updated initscript tests (jskladan and mkrizek)
- Use a single method for @ExceptionCatcher handling (jskladan)
- Correct missing config_loader import (jlaska)
- Upgradepath cleanups and disable upgradepath for 'updates-testing' repo (kparal)
- Automatically log all test output to $resultsdir/output.log (kparal)
- Include traceback in email output (kparal)
- Allow tests to distinguish CRASHED and ABORTED (kparal)
- Install hunspell-en during setup() for rpmlint (jlaska)

* Fri Sep 17 2010 James Laska <jlaska@redhat.com> - 0.4.2-1
- Minor bug fixes (rats_sanity, upgradepath, autoqa) (jlaska)
- Move watcher cronjob into documentation directory (jlaska)
- Don't reboot clients before or after test run (jlaska)

* Thu Sep 16 2010 James Laska <jlaska@redhat.com> - 0.4.1-1
- Corrected several multihook test issues (kparal+jskladan)
- Enable assertions for autoqa tests (kparal)
- Updated rats_sanity comps.rng URL (wwoods)
- Moved watcher cronjob to /usr/share/doc/autoqa (jlaska)
- Updated israwhidebroken to locate correct cherrypy version (jlaska)

* Tue Aug 30 2010 James Laska <jlaska@redhat.com> - 0.4.0-1
- Ticket#123 - Add upgrade-path test (vaschenb)
- Ticket#195 - Add Helloworld test for hook verification (vaschenb)
- Ticket#199 - Standardize test arguments between hooks (kparal)
- Ticket#200 - Support for control.autoqa (kparal)
- Ticket#207 - Use correct list of tags when looking for koji builds (jlaska)
- Ticket#210 - renamed url parameter to baseurl (jskladan)
- Ticket#211 - update repoinfo.conf for new F-14 branch repo (jlaska)
- Replace repoinfo.conf on upgrade (kparal)
- New AutoQATest base class for test objects (jskladan)
- Add post-bodhi-update watcher to crontab (kparal)
- Treat ghost files appropriately in potential_conflicts.py, i.e. match rpm's
  behaviour (fcami)
- Add repoinfo.getreleases() and get_bodhi_releases() (wwoods)
- Use repoinfo data for bodhi_releases in the bodhi watcher (wwoods)
- Add support for autotest labels in autoqa harness (kparal)

* Tue Jul 06 2010 James Laska <jlaska@redhat.com> - 0.3.5-1
- Move common methods from post-bodhi-update into bodhi_utils.py (wwoods)
- Require autotest, not autotest-client (jlaska)
- Initial post-bodhi-update watcher and test templates (wwoods)
- Add composes keyword to repoinfo.conf and repoinfo.py (wwoods)
- Correct repoinfo.conf to match Fedora branch process (jlaska)
- Add post-koji-build --prevtime and --verbose options (jlaska)
- Add support to koji_utils.py to get previously tagged package for packages
  with no parent repository (wwoods)

* Mon May 26 2010 James Laska <jlaska@redhat.com> - 0.3.4-1
- Correct handling of config variable in tests (jskladan)

* Mon May 25 2010 James Laska <jlaska@redhat.com> - 0.3.3-1
- Ticket#130 - Support for providing URL to autotest server logs (jskladan)
- Ticket#151 - opt-in support to subscribe to test results for your package
  (svidal)
- Update repoinfo.conf for Fedora 14 and Fedora 13 release (jlaska)

* Mon Apr 12 2010 James Laska <jlaska@redhat.com> - 0.3.2-1
- Config files moved to /etc/autoqa directory (kparal)
- Don't overwrite config files during 'make install' (kparal)
- Ticket#120 - New initscript test for validating select SysV initscripts
  (jskladan)
- Ticket#119 - Add [Branched] to default repoinfo.conf (jlaska)
- Post-tree-compose no longer monitors rawhide for new install images (jlaska)

* Mon Mar 8 2010 James Laska <jlaska@redhat.com> - 0.3.1-1
- The autoqa version should change whenever the tarball changes.  Adjust to new
  version-release scheme.
- Ticket#114 - Updates to koji_utils and rpmguard to detect previous released
  packages (kparal)
- Ticket#116 - Update koji watcher to accept ENVR not just NVR (kparal)
- Ticket#119 - Update repoinfo.conf and post-koji-build to accommodate no
  frozen rawhide changes (jlaska)
- sanity.py - Fix subtle loop bug that caused us to randomly skip packages
  (wwoods)
- Ticket#107 - Initial automated DVD install test dvd_install.py (lili)
- Update rats.py to support test-specific command-line arguments via
  OptionGroup (jlaska)

* Tue Jan 12 2010 James Laska <jlaska@redhat.com> - 0.3-3
- Add rpmguard test (kparal)
- Several updates to virtguest.py supporting multiple disks (wwoods)

* Wed Dec 2 2009 James Laska <jlaska@redhat.com> - 0.3-2
- Add autoqa-israwhidebroken TurboGears application
- Remove .py extension from israwhidebroken _sbindir scripts

* Fri Nov 6 2009 Will Woods <wwoods@redhat.com> - 0.3-1
- Rearrange a bunch of test/watcher code into autoqa python lib
- Add post-koji-build hook and watcher

* Thu Aug 6 2009 Will Woods <wwoods@redhat.com> - 0.2-1
- Big autotest rearrange

* Tue Jun 30 2009 James Laska <jlaska@redhat.com> - 0.1-1
- Initial packaging
